#!/bin/sh

# define default configuration
POLL=false
SMP=auto
ERL_MAX_PORTS=32000
ERL_PROCESSES=250000
ERL_MAX_ETS_TABLES=1400

# define default environment variables
NODE=ejabberd
HOST=`hostname -s`
ERLANG_NODE=$NODE@$HOST
ERL=/usr/local/bin/erl
ROOTDIR=/usr/local
EJABBERD_CONFIG_PATH=/etc/ejabberd/ejabberd.cfg
LOGS_DIR=/var/log/ejabberd
EJABBERD_DB=/var/db/ejabberd/${NODE}
ID=`id -g`
EJID=`id -g _ejabberd`

# read custom configuration
CONFIG=/etc/ejabberd/ejabberdctl.cfg
[ -f "$CONFIG" ] && . "$CONFIG"

# parse command line parameters
ARGS=
while [ $# -ne 0 ] ; do
    PARAM=$1
    shift
    case $PARAM in
        --) break ;;
        --node) ERLANG_NODE=$1; shift ;;
        --config) EJABBERD_CONFIG_PATH=$1 ; shift ;;
        --ctl-config) CONFIG=$1 ; shift ;;
        --logs) LOGS_DIR=$1 ; shift ;;
        --spool) EJABBERD_DB=$1 ; shift ;;
        *) ARGS="$ARGS $PARAM" ;;
    esac
done

NODE="${ERLANG_NODE%@*}"
EJABBERD_DB=/var/db/ejabberd/$NODE

NAME=-name
[ "$ERLANG_NODE" = "${ERLANG_NODE%.*}" ] && NAME=-sname

ERLANG_OPTS="+K $POLL -smp $SMP +P $ERL_PROCESSES"

# define additional environment variables
EJABBERD_EBIN=/usr/local/lib/ejabberd/ebin
EJABBERD_MSGS_PATH=/usr/local/lib/ejabberd/priv/msgs
EJABBERD_SO_PATH=/usr/local/lib/ejabberd/priv/lib
EJABBERD_BIN_PATH=/usr/local/lib/ejabberd/priv/bin
EJABBERD_LOG_PATH=${LOGS_DIR}/${NODE}.log
SASL_LOG_PATH=${LOGS_DIR}/${NODE}_sasl.log
DATETIME=`date "+%Y%m%d-%H%M%S"`
ERL_CRASH_DUMP=${LOGS_DIR}/erl_crash_${DATETIME}.dump
ERL_INETRC=/etc/ejabberd/inetrc
HOME=/var/db/ejabberd

# make sure we execute commands as proper user
if [ $ID -eq 0 ]; then
	EXEC_CMD='sudo -c - -u _ejabberd'
else
	EXEC_CMD=''
fi

# export global variables
export EJABBERD_CONFIG_PATH
export EJABBERD_MSGS_PATH
export EJABBERD_LOG_PATH
export EJABBERD_SO_PATH
export EJABBERD_BIN_PATH
export ERL_CRASH_DUMP
export ERL_INETRC
export ERL_MAX_PORTS
export ERL_MAX_ETS_TABLES
export EXEC_CMD
export HOME

# Compatibility in ZSH
#setopt shwordsplit 2>/dev/null

# start server
start ()
{
    ${EXEC_CMD} $ERL \
      $NAME $ERLANG_NODE \
      -noinput -detached \
      -pa $EJABBERD_EBIN \
      -kernel inetrc \"${ERL_INETRC}\" \
      -mnesia dir "\"$EJABBERD_DB\"" \
      -s ejabberd \
      -ejabberd config \"${EJABBERD_CONFIG_PATH}\" \
      log_path \"${EJABBERD_LOG_PATH}\" \
      -sasl sasl_error_logger \{file,\"$SASL_LOG_PATH\"\} \
      $ERLANG_OPTS $ARGS "$@"
}

# attach to server
debug ()
{
    echo "--------------------------------------------------------------------"
    echo ""
    echo "IMPORTANT: we will attempt to attach an INTERACTIVE shell"
    echo "to an already running ejabberd node."
    echo "If an ERROR is printed, it means the connection was not succesfull."
    echo "You can interact with the ejabberd node if you know how to use it."
    echo "Please be extremely cautious with your actions,"
    echo "and exit immediately if you are not completely sure."
    echo ""
    echo "To detach this shell from ejabberd, press:"
    echo "  control+c, control+c"
    echo ""
    echo "--------------------------------------------------------------------"
    echo "Press any key to continue"
    read foo
    echo ""
    ${EXEC_CMD} $ERL \
      $NAME ${NODE}debug \
      -remsh $ERLANG_NODE \
      $ERLANG_OPTS $ARGS "$@"
}

# start interactive server
live ()
{
    echo "--------------------------------------------------------------------"
    echo ""
    echo "IMPORTANT: ejabberd is going to start in LIVE (interactive) mode."
    echo "All log messages will be shown in the command shell."
    echo "You can interact with the ejabberd node if you know how to use it."
    echo "Please be extremely cautious with your actions,"
    echo "and exit immediately if you are not completely sure."
    echo ""
    echo "To exit this LIVE mode and stop ejabberd, press:"
    echo "  q().  and press the Enter key"
    echo ""
    echo "--------------------------------------------------------------------"
    echo "Press any key to continue"
    read foo
    echo ""
    ${EXEC_CMD} $ERL \
      $NAME $ERLANG_NODE \
      -pa $EJABBERD_EBIN \
      -kernel inetrc \"${ERL_INETRC}\" \
      -mnesia dir "\"$EJABBERD_DB\"" \
      -s ejabberd \
      -ejabberd config \"${EJABBERD_CONFIG_PATH}\" \
      log_path \"${EJABBERD_LOG_PATH}\" \
      $ERLANG_OPTS $ARGS "$@"
}

# common control function
ctl ()
{
    ${EXEC_CMD} $ERL \
      $NAME ejabberdctl \
      -noinput \
      -pa $EJABBERD_EBIN \
      -s ejabberd_ctl -extra $ERLANG_NODE $@
    result=$?
    case $result in
    0) :;;
    *)
        echo ""
        echo "Commands to start an ejabberd node:"
        echo "  start  Start an ejabberd node in server mode"
        echo "  debug  Attach an interactive Erlang shell to a running ejabberd node"
        echo "  live   Start an ejabberd node in live (interactive) mode"
        echo ""
        echo "Optional parameters when starting an ejabberd node:"
        echo "  --config file      Config file of ejabberd:    $EJABBERD_CONFIG_PATH"
        echo "  --ctl-config file  Config file of ejabberdctl: $CONFIG"
        echo "  --logs dir         Directory for logs:         $LOGS_DIR"
        echo "  --spool dir        Database spool dir:         $EJABBERD_DB"
        echo "  --node nodename    ejabberd node name:         $ERLANG_NODE"
        echo "";;
    esac
    return $result
}

# display ctl usage
usage ()
{
    ctl
    exit
}

# check if we're a user that can execute commands
if [ "$ID" -ne 0 -a "$ID" -ne "$EJID" ]; then
	echo "this command can only be run by root or the _ejabberd user" >&2
	EXEC_CMD='false'
	usage
fi

if [ ! -d $EJABBERD_DB -o ! -w $EJABBERD_DB ] ; then
	if [ ! -d ${EJABBERD_DB%/*} -o ! -w ${EJABBERD_DB%/*} ] ; then
		echo "${EJABBERD_DB} does not exist and I can't create it!"
		exit 1
	fi
fi

case $ARGS in
    ' start') start;;
    ' debug') debug;;
    ' live') live;;
    *) ctl $ARGS;;
esac
